// C Source File
// Created 11/2/2002; 12:24:36 AM

#define KEY_UPLEFT 339
#define KEY_DOWNRIGHT 348
#define USE_TI89              // Produce .89z File

#define RETURN_VALUE

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "3D.H"


// Main Function
ESI arg;
short _ti89;                  // Produce .89Z File
void CalculatePoints();
void DrawCoords();
void DrawWires();
void FillSurfaces();
void GetAvgValues();
void goodbye();
void init();
void intro();
void Redraw();
void SortZValues();
SCR_RECT FULLSCR;

#if 0
void RotateAroundX(double);
void RotateAroundY(double);
void RotateAroundZ(double);
#endif

int LINES [12][2] = {{0, 1}, {1, 2}, {2, 3}, {3, 0}, {4, 0}, {4, 1}, {4, 2}, {4, 3}, {5, 0}, {5, 1}, {5, 2}, {5, 3}};
ScrPoint SP_OBJ [6];
int face_order[8];
int Z_Average_Value[8];
static boolean fill = false;
static boolean wire = true;
int numlines = 12, numpoints = 6, numfaces = 8, numverticesperface = 3;
int iter;

boolean camera_moved = false;
unsigned short key;
static int x = 0, y = 0, z = 50;


static Vertex OBJ [6] = {{10, 0, 0}, {0, 10, 0}, {-10, 0, 0}, {0, -10, 0}, {0, 0, -10}, {0, 0, 10}};

int FACE[8][3] = {{0, 1, 4}, {0, 1, 5}, {1, 2, 4}, {1, 2, 5}, {2, 3, 4}, {2, 3, 5}, {3, 0, 4}, {3, 0, 5}};

unsigned char angle = '-'; // ASCII character #45, for a 45 degree angle
	
int P1_x, P2_x, P1_y, P2_y;

void _main(void)
{
  InitArgPtr(arg); // set arg to point to the first argument
  if(GetArgType(arg) == POSINT_TAG) {
  	switch(GetIntArg(arg)){
  		case 0: fill = false; break;
  		case 1: fill = true; break;
  		case 2: fill = true; wire = false; break;
  		case 3: fill = true; wire = true; break;
  	}
  }
	void *kbq = kbd_queue ();
	FULLSCR.xy.x0 = 0;
	FULLSCR.xy.x1 = 159;
	FULLSCR.xy.y0 = 0;
	FULLSCR.xy.y1 = 99;

	init();
	quit = false;
	intro();
	if(quit) goto a;
	GrayOn();
	SetPlane(0);
	ClrScr();
	SetPlane(1);
	ClrScr();
	DrawWires();

	FillSurfaces();
	
	key = 0;
	while (key != KEY_ESC) {
   	camera_moved = false;
		while(!OSdequeue (&key, kbq)) {
			camera_moved = true;
	    switch(key) {
				case KEY_UP: case KEY_UP + 0x800: y++; break;
				case KEY_DOWN: case KEY_DOWN + 0x800: y--; break;
		    case KEY_LEFT: case KEY_LEFT + 0x800: x--; break;
		    case KEY_RIGHT: case KEY_RIGHT + 0x800: x++; break;
		    case KEY_DOWNLEFT: case KEY_DOWNLEFT + 0x800: x--; y--; break;
		    case KEY_UPLEFT: case KEY_UPLEFT + 0x800: x--; y++; break;
		    case KEY_DOWNRIGHT: case KEY_DOWNRIGHT + 0x800: x++; y--; break;
		    case KEY_UPRIGHT: x++; y++; break;
				case KEY_F1: z--; break;
				case KEY_F2: z++; break;
				case KEY_F3: fill = (!fill); break;
				case KEY_F4: wire = (!wire); break;
				default: camera_moved = false; break;
			}
			if(camera_moved) {
				moveCamera(x, y);
				setCameraDistance(z);
				Redraw();
			}
	  }
	}
a:
  push_ANSI_string((char *)"lord_nightrose@yahoo.com\0");
	GrayOff();
	atexit(goodbye);
}

void CalculatePoints() {
	int p;
	
	for (p = 0; p < numpoints; p++) { // For all the points...
	
	   // Store the values in the Work object
	
	   Work.x = OBJ[p].x - Camera.x;
	   Work.y = OBJ[p].y - Camera.y;
	   Work.z = OBJ[p].z - Camera.z;
	
	   // Calculate the ScrPoints
	
	   SP_OBJ[p].x = Screen_center.x + (64 * Work.x) / Work.z;
	   SP_OBJ[p].y = Screen_center.y - (64 * Work.y) / Work.z;
	
	}
}

void DrawWires() {
	if(wire || (!wire && !fill)) {
		int l;
		for (l=0; l < numlines; l++) { // For all the lines...
			
		   P1_x = SP_OBJ[LINES[l][0]].x; // First Point x value...
		   P1_y = SP_OBJ[LINES[l][0]].y; // First Point y value...
		   P2_x = SP_OBJ[LINES[l][1]].x; // Second Point x value...
		   P2_y = SP_OBJ[LINES[l][1]].y; // Second Point y value...
		
		   // Now draw the line between the 2 points.
			 SetPlane(0);
		   DrawLine(P1_x, P1_y, P2_x, P2_y, A_NORMAL);
			 SetPlane(1);
		   DrawLine(P1_x, P1_y, P2_x, P2_y, A_NORMAL);
		}
	}
}

void Redraw() {
	SetPlane(0);
	ClrScr();
	SetPlane(1);
	ClrScr();
	CalculatePoints();
	FillSurfaces();
	DrawWires();
}

#if 0
void RotateAroundX(double ang_x) {
	int i;
	double intermediate;
	ang_x /= DEGREE / 10;
	for(i=0;i<9;i++) {
		Work=OBJ[i];
		intermediate = Work.z; // intermediate value
		Work.z = - Work.y * sin(ang_x) + Work.z * cos(ang_x);
		Work.y = Work.y * cos(ang_x)  + intermediate * sin(ang_x);
		OBJ[i]=Work;
	}
}

void RotateAroundY(double ang_y) {
	int i;
	double intermediate;
	ang_y /= DEGREE / 100;
	for(i=0;i<9;i++) {
		Work=OBJ[i];
		intermediate = Work.z; // intermediate value
		Work.z = - Work.x * sin(ang_y) - Work.z * cos(ang_y);
		Work.x = - Work.x * cos(ang_y) + intermediate * sin(ang_y);
		OBJ[i]=Work;
	}
}

void RotateAroundZ(double ang_z) {
	int i;
	double intermediate;
	ang_z /= DEGREE / 10;
	for(i=0;i<9;i++) {
		Work=OBJ[i];
		intermediate = Work.z; // intermediate value
		Work.x = Work.x * cos(ang_z) - Work.y * sin(ang_z);
		Work.y = Work.y * cos(ang_z) + intermediate * sin(ang_z);
		OBJ[i]=Work;
	}
}
#endif

void FillSurfaces() {
	if(!fill) return;
	ScrPoint p1, p2, p3;
	for(iter = 0; iter < numfaces; iter++)
		face_order[iter] = iter;
	GetAvgValues();
	SortZValues();
	for(iter = 0; iter < numfaces; iter++) {
		p1 = SP_OBJ[FACE[face_order[iter]][0]];
		p2 = SP_OBJ[FACE[face_order[iter]][1]];
		p3 = SP_OBJ[FACE[face_order[iter]][2]];
		if(iter <= numfaces / 4) {
			SetPlane(LIGHT_PLANE);
			FillTriangle(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, &FULLSCR, A_NORMAL);
			FillTriangle(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, &FULLSCR, A_REVERSE);
			SetPlane(DARK_PLANE);
			FillTriangle(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, &FULLSCR, A_NORMAL);
		} else if(iter > numfaces / 4 && iter <= numfaces / 2) {
			SetPlane(LIGHT_PLANE);
			FillTriangle(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, &FULLSCR, A_NORMAL);
		}
	}
}

void GetAvgValues() {
	int v, vrtx; 
	for (iter = 0; iter < numfaces; iter++) { // For all the faces...
	
	   Z_Average_Value[iter] = 0; // Init
	
	   for (v = 0; v < numverticesperface; v++) { // For all the Vertices of each face...
	     vrtx = FACE [iter][v]; // The number of the current Vertex is stored in face 'iter', Vertex number 'v'
		   Z_Average_Value[iter] +=  OBJ[vrtx].z;  // add the Z-Value of the vertices contained in the face
	   }
	
	// Then divide by the number of vertices per face, to get the 'Average'
	
	Z_Average_Value[iter] = Z_Average_Value[iter] / numfaces;
	
	// That last line is not necessary, since all the faces have 4 vertices in a OBJ.
	}
}

void SortZValues() {
	// flag is set to 1 if a swap occurs...

	int flag = 1;
	int intermediate;
	int face, face_next;
	
	// Until there is no swapping done in a full pass...
	while (flag == 1) {
	  
	  flag = 0; 

    for (iter = 0; iter < numverticesperface; iter++) {

// read the face in 'face_order'

     face = face_order[iter];
     face_next = face_order[iter+1];
 
// if the z value of face_next is greater than the z value in face, swap them
         
	    if (Z_Average_Value[face] < Z_Average_Value[face_next]) {
		// We're doing a swap, so flag=1;
		    flag = 1;
		    intermediate = face_order[iter];
		    face_order[iter] = face_order[iter+1];
		    face_order[iter+1] = intermediate;  
			}
		}
	}
}

void init() {
	FontSetSys(F_4x6);
	setCameraDistance(50);
	CalculatePoints();
}

void goodbye() {
	ST_helpMsg(";-p see you later");
	ngetchx();	
}
